package com.yunzhi.niucai.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.yunzhi.niucai.common.BaseController;
import com.yunzhi.niucai.common.ResponseBean;
import com.yunzhi.niucai.enums.StatusEnum;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import com.yunzhi.niucai.service.ITaCustomerService;
import com.yunzhi.niucai.entity.TaCustomer;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

/**
 * <p>
    * 客户 前端控制器
    * </p>
 *
 * @author yansen
 * @since 2020-08-28
 */

@Api(tags = "用户管理")
@RestController
@RequestMapping("/")
public class TaCustomerController extends BaseController {

    private final Logger logger = LoggerFactory.getLogger(TaCustomerController.class);

    @Autowired
    public ITaCustomerService iTaCustomerService;

//
//    /**
//     * 分页查询列表
//     * @param pageNum
//     * @param pageSize
//     * @return
//     */
//    @RequestMapping(value="/taCustomer",method= RequestMethod.GET)
//    @ApiOperation(value="列表", notes = "列表", httpMethod = "GET", response = ResponseBean.class)
//    public ResponseBean taCustomerList(@ApiParam("页码") @RequestParam(value ="pageNum",defaultValue = "1") Integer pageNum,
//									 @ApiParam("单页数据量") @RequestParam(value ="pageSize",defaultValue = "10") Integer pageSize) throws Exception{
//
//		    IPage<TaCustomer> pg = new Page<>(pageNum, pageSize);
//            QueryWrapper<TaCustomer> queryWrapper = new QueryWrapper<>();
//            queryWrapper.orderByDesc("create_date");
//
//            IPage<TaCustomer> result = iTaCustomerService.page(pg, queryWrapper);
//            return ResponseBean.success(result);
//    }
//
//    /**
//     * 保存对象
//     * @param taCustomer 实体对象
//     * @return
//     */
//    @RequestMapping(value="/taCustomer",method= RequestMethod.POST)
//    @ApiOperation(value="保存", notes = "保存", httpMethod = "POST", response = ResponseBean.class)
//    public ResponseBean taCustomerAdd(@ApiParam("保存内容") @RequestBody TaCustomer taCustomer) throws Exception{
//
//        if (iTaCustomerService.save(taCustomer)){
//            return ResponseBean.success(taCustomer);
//        }else {
//            return ResponseBean.error("保存失败, 请重试", ResponseBean.ERROR_UNAVAILABLE);
//        }
//    }
//
//    /**
//     * 根据id删除对象
//     * @param id  实体ID
//     */
//    @RequestMapping(value="/taCustomer/{id}", method= RequestMethod.DELETE)
//    @ApiOperation(value="删除", notes = "删除", httpMethod = "DELETE", response = ResponseBean.class)
//    public ResponseBean taCustomerDelete(@ApiParam("对象ID") @PathVariable Integer id) throws Exception{
//        if(iTaCustomerService.removeById(id)){
//            return ResponseBean.success("success");
//        }else {
//            return ResponseBean.error("删除失败, 请重试", ResponseBean.ERROR_UNAVAILABLE);
//        }
//    }
//
//    /**
//     * 修改对象
//     * @param id  实体ID
//     * @param taCustomer 实体对象
//     * @return
//     */
//    @RequestMapping(value="/taCustomer/{id}",method= RequestMethod.PUT)
//    @ApiOperation(value="更新", notes = "更新", httpMethod = "PUT", response = ResponseBean.class)
//    public ResponseBean taCustomerUpdate(@ApiParam("对象ID") @PathVariable Integer id,
//                                        @ApiParam("更新内容") @RequestBody TaCustomer taCustomer) throws Exception{
//
//        if (iTaCustomerService.updateById(taCustomer)){
//            return ResponseBean.success(iTaCustomerService.getById(id));
//        }else {
//            return ResponseBean.error("修改失败, 请重试", ResponseBean.ERROR_UNAVAILABLE);
//        }
//    }

    /**
     * 根据id查询对象
     * @param id  实体ID
     */
    @RequestMapping(value="/app/customer/{id}",method= RequestMethod.GET)
    @ApiOperation(value="根据id查询用户", notes = "用户信息: 如果 id 设置为 current , 则代表查询当前用户", httpMethod = "GET", response = ResponseBean.class)
    public ResponseBean taCustomerGet(@ApiParam("用户 ID") @PathVariable String id,
                                      HttpServletRequest request) throws Exception{
        TaCustomer customer = null;
        if ("current".equals(id)) {
            customer = getCustomer(request);
        } else {
            customer = iTaCustomerService.getById(id);
        }

        if (null == customer || StatusEnum.DELETED.getCode().equals(customer.getStatus())) {
            return ResponseBean.error("未查询到人员信息", ResponseBean.ERROR_UNAVAILABLE);
        }

        customer.setCashPass(null);
        customer.setLoginPass(null);
        return ResponseBean.success(customer);
    }
}
