package com.yunzhi.niucai.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.yunzhi.niucai.entity.TaMatchOdds;
import com.yunzhi.niucai.mapper.TaMatchOddsMapper;
import com.yunzhi.niucai.service.ITaMatchOddsService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 赔率 服务实现类
 * </p>
 *
 * @author yansen
 * @since 2020-09-02
 */
@Service
public class TaMatchOddsServiceImpl extends ServiceImpl<TaMatchOddsMapper, TaMatchOdds> implements ITaMatchOddsService {

    @Override
    public TaMatchOdds getByMatchAndRule(String lotteryId, Integer matchId, String ruleCode) throws Exception {
        QueryWrapper<TaMatchOdds> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("lottery_id", lotteryId);
        queryWrapper.eq("match_id", matchId);
        queryWrapper.eq("rule_code", ruleCode);
        queryWrapper.last("limit 1");

        return getOne(queryWrapper);
    }

    @Override
    public Map<String, TaMatchOdds> getGroupedByRule(Integer matchId) throws Exception {
        QueryWrapper<TaMatchOdds> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("match_id", matchId);

        List<TaMatchOdds> list = list(queryWrapper);
        if (null == list || list.size() == 0) {
            return null;
        }

        Map<String, TaMatchOdds> res = new HashMap<>();
        for (TaMatchOdds taMatchOdds: list) {
            res.put(taMatchOdds.getRuleCode(), taMatchOdds);
        }
        return res;
    }
}
