package com.yunzhi.niucai.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.yunzhi.niucai.common.DateUtils;
import com.yunzhi.niucai.entity.TaMatch;
import com.yunzhi.niucai.entity.TaMatchOdds;
import com.yunzhi.niucai.enums.SportStatusEnum;
import com.yunzhi.niucai.mapper.TaMatchMapper;
import com.yunzhi.niucai.mapper.TaMatchOddsMapper;
import com.yunzhi.niucai.service.ITaMatchService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 比赛  服务实现类
 * </p>
 *
 * @author yansen
 * @since 2020-09-02
 */
@Service
public class TaMatchServiceImpl extends ServiceImpl<TaMatchMapper, TaMatch> implements ITaMatchService {

    @Autowired
    TaMatchMapper taMatchMapper;

    @Autowired
    TaMatchOddsMapper taMatchOddsMapper;

    @Override
    public List<TaMatch> getMixedMatch(String lottery) throws Exception {
        List<TaMatch> taMatches = taMatchMapper.getMixedMatch(lottery, SportStatusEnum.SALE.getCode());
        if (null == taMatches) {
            return null;
        }

        for (TaMatch match : taMatches) {
            List<Map<String, Object>> oddList = taMatchOddsMapper.getByMatch(match.getMatchId());
            if (null != oddList) {
                Map<String, List<Map<String, Object>>> odds = new HashMap<>();

                String key = "";
                List<Map<String, Object>> list = new ArrayList<>();
                for (Map<String, Object> item : oddList) {
                    String wayCode = item.get("wayCode").toString();
                    if (!key.equals(wayCode)) {
                        key = wayCode;
                        list = new ArrayList<>();
                        odds.put(key, list);
                    }
                    list.add(item);
                }

                match.setPlayOdds(odds);
            }
        }

        return taMatches;
    }
}
